<template>
  <div>
    <li class="title"><h1>我的自定义赛事</h1></li>
    <a-button type="primary" @click="showModal">
      上传自定义赛事
    </a-button>
    <br/><br/>
    <a-modal v-model="modal_visible" title="填写自定义赛事信息"
              @ok="handleSubmit()"
              :confirmLoading="confirmLoading"
              :destroyOnClose="true">
      <a-form :form="new_cust_form" :label-col="{ span: 5 }" :wrapper-col="{ span: 12 }">
        <a-form-item label="比赛名称">
          <a-input placeholder="请输入比赛名称（不能超过32个字符）"
                    :maxLength="32"
                    v-decorator="['game_name', {
                      rules: [
                          { required: true, message: '请输入比赛名称！'},
                          {max: 32, message: '比赛名称不能超过32个字符'}
                      ]}]"
          />
        </a-form-item>
        <a-form-item label="起止时间">
          <a-range-picker
              :disabled-date="disabledDate"
              :disabled-time="disabledRangeTime"
              :show-time="{
      hideDisabledOptions: true,
      defaultValue: [moment('00:00:00', 'HH:mm:ss'), moment('11:59:59', 'HH:mm:ss')]
    }"
              format="YYYY-MM-DD HH:mm:ss"
              v-decorator="['cust_game_time', { rules: [{ required: true, message: '请选择起止时间！'}] }]"
          />
        </a-form-item>
        <a-form-item label="比赛链接">
          <a-input placeholder="请输入比赛链接（不能超过100个字符）"
                    :maxLength="100"
                    v-decorator="['website', {
                      rules: [
                          { required: true, message: '请输入比赛链接！'},
                          { max: 100, message: '比赛链接不能超过100个字符！'}
                      ]}]"
          />
        </a-form-item>
        <a-form-item label="举办方">
          <a-select v-decorator="['platform', { rules: [{ required: true, message: '请选择举办方！'}] }]"
                    placeholder="请选择">
            <a-select-option value="codeforces">codeforces</a-select-option>
            <a-select-option value="atcoder">atcoder</a-select-option>
            <a-select-option value="力扣">力扣</a-select-option>
            <a-select-option value="牛客网">牛客网</a-select-option>
            <a-select-option value="洛谷">洛谷</a-select-option>
            <a-select-option value="自定义">自定义</a-select-option>
          </a-select>
        </a-form-item>
        <a-form-item label="难度">
          <a-radio-group v-decorator="['level', { rules: [{ required: true, message: '请选择难度！'}] }]">
            <a-radio :value="1">简单</a-radio>
            <a-radio :value="2">中等</a-radio>
            <a-radio :value="3">困难</a-radio>
          </a-radio-group>
        </a-form-item>
        <a-form-item label="是否公开">
          <a-switch default-checked
                    v-decorator="['cust_public', {initialValue: true, rules: [{ required: true}] }]"></a-switch>
        </a-form-item>
      </a-form>
    </a-modal>
    <a-table rowKey="game_id" :columns="tableColumns" :data-source="this.cust_matches">
      <span slot="website" slot-scope="text, record"><a :href="record.website" target="_blank">{{
          record.website
        }}</a></span>
      <span slot="public" slot-scope="text, record">{{ record.cust_public ? '公开' : '私密' }}</span>
      <template slot="operation" slot-scope="text, record, index">
        <a class="operation" @click="handleDelete(record, index)">删除</a>
      </template>
    </a-table>
  </div>
</template>
<script>
import moment from 'moment';
//自定义比赛信息表
const tableColumns = [
  {
    title: '比赛名',
    dataIndex: 'game_name',
    key: 'game_name',
    width: '20%',

  },
  {
    title: '开始时间',
    dataIndex: 'game_start_time',
    key: 'game_start_time',
    width: '15%',
  },
  {
    title: '结束时间',
    dataIndex: 'game_end_time',
    key: 'game_end_time',
    width: '15%',
  },
  {
    title: '比赛链接',
    dataIndex: 'website',
    key: 'website',
    width: '250px',
    scopedSlots: {customRender: 'website'},
  },
  {
    title: '举办方',
    dataIndex: 'platform',
    key: 'platform',
    width: '10%',
  },
  {
    title: '公开状态',
    dataIndex: 'cust_public',
    key: 'cust_public',
    width: '10%',
    scopedSlots: {customRender: 'public'},
  },
  {
    title: '操作',
    key: 'operation',
    width: '50px',
    scopedSlots: {customRender: 'operation'},
  },
]
export default {
  data() {
    return {
      matches: [],
      cust_matches: [],
      modal_visible: false,
      tableColumns,
      new_cust_form: this.$form.createForm(this, {name: 'new_game'}),
      confirmLoading: false,
    }
  },

  mounted: function () {
    this.getUserCustomGamesList()
  },

  methods: {
    moment,
    getUserCustomGamesList() {
      this.$axios.get('game/custom/query/user').then((res) => {
        if (res.code == undefined) {
          this.cust_matches = res
        }
      }).catch(() => {
      });
    },
    showModal() {
      this.modal_visible = true;
    },
    disabledDate(current) {
      return current && current < moment().endOf('day');
    },
    disabledRangeTime() {
      return;
    },
    handleDelete(record, index) {
      this.$axios.post('game/delete', {
        game_id: record.game_id
      }).then(res => {
        if (res.code == 0) {
          this.$notification.success({message: '已删除'})
          this.cust_matches.splice(index, 1)
        } else {
          this.$notification.error({message: '删除失败'})
        }
      }).catch(() => {
        this.$notification.error({message: '删除失败'})
      })
    },
    handleSubmit() {
      this.new_cust_form.validateFields(async (err, values) => {
        if (!err) {
          this.confirmLoading = true
          let params = {}
          params.game_name = values.game_name
          params.game_start_time = this.$moment(values.cust_game_time[0]).format('yyyy-MM-DD HH:mm:ss')
          params.game_end_time = this.$moment(values.cust_game_time[1]).format('yyyy-MM-DD HH:mm:ss')
          params.website = values.website
          params.platform = values.platform
          params.level = values.level
          params.cust_public = values.cust_public ? 1 : 0
          await this.$axios.post("game/add", params).then((res) => {
            if (res.code == 0) {
              this.$message.success('添加成功')
              this.modal_visible = false;
              this.new_cust_form.clearField();
              this.getUserCustomGamesList()
            } else {
              this.$message.success('添加失败')
            }
          }).catch(() => {
            this.$message.success('添加失败')
          });
          this.confirmLoading = false
        }
      });
    }
  },
};
</script>

<style lang="less" scoped>
.title {
    border-left: 5px solid #517E55;
    padding-left: 20px;
    height: 30px;
    margin: 20px 0;
    font-weight: bold;
    vertical-align: baseline;

    h1 {
      line-height: 28px;
    }
}

li {
  margin: 5px;
}

li::marker {
  content: '';
}
</style>